searchNodes=[{"doc":"Surface is component based library for Phoenix LiveView. Built on top of the new Phoenix.LiveComponent API, Surface provides a more declarative way to express and use components in Phoenix. Full documentation and live examples can be found at surface-demo.msaraiva.io This module defines the ~H sigil that should be used to translate Surface code into Phoenix templates. In order to have ~H available for any Phoenix view, add the following import to your web file in lib/my_app_web.ex: # lib/my_app_web.ex ... def view do quote do ... import Surface end end Defining components To create a component you need to define a module and use one of the available component types: Surface.Component - A stateless component. Surface.LiveComponent - A live stateful component. Surface.LiveView - A wrapper component around Phoenix.LiveView. Surface.MacroComponent - A low-level component which is responsible for translating its own content at compile time. Example # A functional stateless component defmodule Button do use Surface.Component property click, :event property kind, :string, default: &quot;is-info&quot; def render(assigns) do ~H&quot;&quot;&quot; &lt;button class=&quot;button {{ @kind }}&quot; phx-click={{ @click }}&gt; &lt;slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end end You can visit the documentation of each type of component for further explanation and examples.","ref":"Surface.html","title":"Surface","type":"module"},{"doc":"","ref":"Surface.html#component/3","title":"Surface.component/3","type":"function"},{"doc":"Translates Surface code into Phoenix templates.","ref":"Surface.html#sigil_H/2","title":"Surface.sigil_H/2","type":"macro"},{"doc":"Defines a stateless component. Example defmodule Button do use Surface.Component property click, :event def render(assigns) do ~H&quot;&quot;&quot; &lt;button class=&quot;button&quot; phx-click={{ @click }}&gt; &lt;slot/&gt; &lt;/button&gt; &quot;&quot;&quot; end end Note: Stateless components cannot handle Phoenix LiveView events. If you need to handle them, please use a Surface.LiveComponent instead.","ref":"Surface.Component.html","title":"Surface.Component","type":"behaviour"},{"doc":"This optional callback is invoked in order to set up a context that can be retrieved for any descendent component.","ref":"Surface.Component.html#c:init_context/1","title":"Surface.Component.init_context/1","type":"callback"},{"doc":"Generates a link that will patch the current LiveView. Provides similar capabilities to Phoenix&#39;s built-in live_patch/2 function. When navigating to the current LiveView, handle_params/3 is immediately invoked to handle the change of params and URL state. Then the new state is pushed to the client, without reloading the whole page. For live redirects to another LiveView, use &lt;LiveRedirect&gt; instead. Properties to :string, required: true - The required path to link to. replace :boolean, default: false - The flag to replace the current history or push a new state. class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element. label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .","ref":"Surface.Components.LivePatch.html","title":"Surface.Components.LivePatch","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LivePatch.html#render/1","title":"Surface.Components.LivePatch.render/1","type":"function"},{"doc":"Generates a link that will redirect to a new LiveView. Provides similar capabilities to Phoenix&#39;s built-in live_redirect/2 function. The current LiveView will be shut down and a new one will be mounted in its place, without reloading the whole page. This can also be used to remount the same LiveView, in case you want to start fresh. If you want to navigate to the same LiveView without remounting it, use &lt;LivePatch&gt; instead. Properties to :string, required: true - The required path to link to. replace :boolean, default: false - The flag to replace the current history or push a new state. class :css_class, default: &quot;&quot; - The CSS class for the generated &lt;a&gt; element. label :string - The label for the generated &lt;a&gt; alement, if no content (default slot) is provided. .","ref":"Surface.Components.LiveRedirect.html","title":"Surface.Components.LiveRedirect","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1.","ref":"Surface.Components.LiveRedirect.html#render/1","title":"Surface.Components.LiveRedirect.render/1","type":"function"},{"doc":"A macro component the does not translate any of its contents. You can use this component when you want to skip translation and write regular Phoenix templates code directly or when you don&#39;t want your HTML to be translated at all. Note: By skipping translation, any syntactic sugar provided by Surface will not apply. Properties","ref":"Surface.Components.Raw.html","title":"Surface.Components.Raw","type":"module"},{"doc":"A live (stateless or stateful) component. A wrapper around Phoenix.LiveComponent. Example defmodule Dialog do use Surface.LiveComponent property title, :string, required: true def mount(socket) do {:ok, assign(socket, show: false)} end def render(assigns) do ~H&quot;&quot;&quot; &lt;div class={{ &quot;modal&quot;, &quot;is-active&quot;: @show }}&gt; &lt;div class=&quot;modal-background&quot;&gt;&lt;/div&gt; &lt;div class=&quot;modal-card&quot;&gt; &lt;header class=&quot;modal-card-head&quot;&gt; &lt;p class=&quot;modal-card-title&quot;&gt;{{ @title }}&lt;/p&gt; &lt;/header&gt; &lt;section class=&quot;modal-card-body&quot;&gt; &lt;slot/&gt; &lt;/section&gt; &lt;footer class=&quot;modal-card-foot&quot; style=&quot;justify-content: flex-end&quot;&gt; &lt;Button click=&quot;hide&quot;&gt;Ok&lt;/Button&gt; &lt;/footer&gt; &lt;/div&gt; &lt;/div&gt; &quot;&quot;&quot; end # Public API def show(dialog_id) do send_update(__MODULE__, id: dialog_id, show: true) end # Event handlers def handle_event(&quot;show&quot;, _, socket) do {:noreply, assign(socket, show: true)} end def handle_event(&quot;hide&quot;, _, socket) do {:noreply, assign(socket, show: false)} end end","ref":"Surface.LiveComponent.html","title":"Surface.LiveComponent","type":"behaviour"},{"doc":"This optional callback is invoked in order to set up a context that can be retrieved for any descendent component.","ref":"Surface.LiveComponent.html#c:init_context/1","title":"Surface.LiveComponent.init_context/1","type":"callback"},{"doc":"A wrapper component around Phoenix.LiveView. Since this module is just a wrapper around Phoenix.LiveView, you cannot define custom properties for it. Only :id and :session are available. However, built-in directives like :for and :if can be used normally. Example defmodule Example do use Surface.LiveView def render(assigns) do ~H&quot;&quot;&quot; &lt;Dialog title=&quot;Alert&quot; id=&quot;dialog&quot;&gt; This &lt;b&gt;Dialog&lt;/b&gt; is a stateful component. Cool! &lt;/Dialog&gt; &lt;Button click=&quot;show_dialog&quot;&gt;Click to open the dialog&lt;/Button&gt; &quot;&quot;&quot; end def handle_event(&quot;show_dialog&quot;, _, socket) do Dialog.show(&quot;dialog&quot;) {:noreply, socket} end end","ref":"Surface.LiveView.html","title":"Surface.LiveView","type":"module"},{"doc":"A low-level component which is responsible for translating its own content at compile time.","ref":"Surface.MacroComponent.html","title":"Surface.MacroComponent","type":"behaviour"},{"doc":"Tranlates the content of the macro component.","ref":"Surface.MacroComponent.html#c:translate/2","title":"Surface.MacroComponent.translate/2","type":"callback"},{"doc":"Defines a behaviour that must be implemented by all HTML/Surface node translators. This module also contains the main logic to translate Surface code.","ref":"Surface.Translator.html","title":"Surface.Translator","type":"behaviour"},{"doc":"","ref":"Surface.Translator.html#c:prepare/2","title":"Surface.Translator.prepare/2","type":"callback"},{"doc":"Translates a string written using the Surface format into a Phoenix template.","ref":"Surface.Translator.html#run/4","title":"Surface.Translator.run/4","type":"function"},{"doc":"Recursively translates nodes from a parsed surface code.","ref":"Surface.Translator.html#translate/2","title":"Surface.Translator.translate/2","type":"function"},{"doc":"","ref":"Surface.Translator.html#c:translate/2","title":"Surface.Translator.translate/2","type":"callback"},{"doc":"","ref":"Surface.Translator.ParseError.html","title":"Surface.Translator.ParseError","type":"exception"}]